<template>
    <div v-cloak>
    <!-- Content Header (Page header) -->
        <div class="content-header pt-4">
            <div class="container-fluid">
                <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0 text-dark">Dashboard
                       
                    </h1>
                </div><!-- /.col -->
                </div><!-- /.row -->
            </div><!-- /.container-fluid -->
        </div>
        <!-- /.content-header -->

        <!-- Main content -->
        <section class="content">
        <div class="container-fluid">
            <!-- Small boxes (Stat box) -->
            <div class="row" v-if="dataLoaded">
                <div class="col-lg-3 col-6">
                    <!-- small box -->
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header bg-primary">
                        <div class="widget-user-image">
                                                         <span class="icon" ><i class="las la-wallet"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username">Finance</h3>
                        <h5 class="widget-user-desc">Année {{ anneEnCours }}</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Résultat <span class="float-right ">{{ entities.ca.result | monnaie}} F cfa</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Entrée <span class="float-right ">{{ entities.ca.entree | monnaie}} F cfa</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Sortie <span class="float-right ">{{ entities.ca.sortie | monnaie}} F cfa</span>
                                    </a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/flux-finances" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <!-- ./col -->
                <div class="col-lg-3 col-6">
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header bg-success">
                        <div class="widget-user-image">
                            <span class="icon" ><i class="las la-book"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username">Location</h3>
                        <h5 class="widget-user-desc">Aperçu général</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    En cours <span class="float-right ">{{ entities.locations_en_cours_count}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Annulé <span class="float-right ">{{ entities.locations_annulees_count}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Total <span class="float-right ">{{ entities.locations_count}}</span>
                                    </a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/locations" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <!-- ./col -->
                <div class="col-lg-3 col-6">
                    <!-- small box -->
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header bg-primary">
                        <div class="widget-user-image">
                            <span class="icon" ><i class="las la-car"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username">Voiture</h3>
                        <h5 class="widget-user-desc">Aperçu général</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">

                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                Avec Documents manquants <span class="float-right ">0</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                En panne <span class="float-right ">0</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">Total <span class="float-right ">31</span></a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/voitures" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <!-- ./col -->
                <div class="col-lg-3 col-6">
                    <!-- small box -->
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header bg-success">
                        <div class="widget-user-image">
                            <span class="icon" ><i class="las la-user-circle"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username">Client</h3>
                        <h5 class="widget-user-desc">Aperçu général</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Année en cours <span class="float-right ">0</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Taux d'augmentation <span class="float-right ">0 %</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Total <span class="float-right ">{{ entities.clients_count}}</span>
                                    </a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/locations" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <!-- ./col -->
            </div>
            <!-- /.row -->
             <div class="row">
                             <div class="col-lg-9 col-md-12 col-sm-12">
                    <chiffre-affaire-graph></chiffre-affaire-graph>
            </div>
            <div class="col-lg-3 col-md-12 col-sm-12 row">
                                <div class="col-lg-12 col-md-6 col-sm-12">
                    <!-- small box -->
                    <div class="small-box bg-primary">
                    <div class="inner" style="padding-bottom:30px;padding-top:30px">
                        
                        <h4>Voiture la plus prolifique</h4>
                        <template v-if="hasBestCar">
                          <p class="text-capitalize">{{ entities.vpp.libelle}}</p>
                          <p class=""> avec  <strong>{{ entities.vpp.result | monnaie}}</strong> F cfa</p>
                        </template>
                        <template v-else>
                            <p class="text-capitalize">Non disponible</p>
                        </template>

                    </div>
                    <div class="icon">
                        <i class="las la-money-bill-wave"></i>
                    </div>
                    <router-link v-if="hasBestCar" :to="'/voitures/'+entities.vpp.id" class="small-box-footer">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                    </div>
                </div>
                <div class="col-lg-12 col-md-6 col-sm-12">
                    <!-- small box -->
                    <div class="small-box bg-success">
                    <div class="inner" style="padding-bottom:30px;padding-top:30px">
                        
                        <h4>Voiture la moins prolifique</h4>

                        <template v-if="hasWorstCar">
                        <p class="text-capitalize">{{ entities.vmp.libelle}}</p>
                        <p class=""> avec  <strong>{{ entities.vmp.result | monnaie}}</strong> F cfa</p>
                        </template>
                        <template v-else>
                         <p class="">Non disponible</p>
                        </template>
                    </div>
                    <div class="icon">
                        <i class="las la-car"></i>
                    </div>
                    <router-link v-if="hasWorstCar" :to="'/voitures/'+entities.vmp.id" class="small-box-footer">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                    </div>
                </div>
                <!-- ./col -->
                <div class="col-lg-12 col-md-12 col-sm-12">
                    <!-- small box -->
                    <div class="small-box bg-primary">
                    <div class="inner" style="padding-bottom:30px;padding-top:30px">
                        
                        <h4>Meilleur client</h4>
                        <template v-if="hasBestClient">
                        <p class="text-uppercase"><span class="text-uppercase">{{ entities.cpp.nom}}</span>  <span class="text-capitalize">{{ entities.cpp.prenom}}</span> </p>
                        <p class=""> avec  <strong>{{ entities.cpp.result | monnaie}}</strong> F cfa</p>
                        </template>
                        <template v-else>
                            <p class="">Non disponible</p>
                        </template>

                    </div>
                    <div class="icon">
                        <i class="las la-award"></i>
                    </div>
                    <router-link v-if="hasBestClient " to="/clients" class="small-box-footer">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                    </div>
                </div>
                <!-- ./col -->
                <!-- ./col -->
            </div>
             </div>

            <div class="row ">
                 <div class="col-lg-9 col-md-12 col-sm-12">
                  <div class="col-lg-12 col-md-12 col-sm-12">
                      <div id="block-last-rent" class="card  ">
                        <div class="card-header">
                            <h3 class="card-title d-flex align-items-center "><i style="font-size:30px" class="las la-book mr-1"></i><b>Dernières locations</b></h3>
                            <div class="card-tools">
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display: block;">
                            <div class="table-responsive" v-if="entities.locations.length > 0">
                                <table class="table m-0">
                                    <thead>
                                        <tr>
                                            <th class="" >Description</th>
                                            <th class="">Déroulement</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="location in entities.locations" :key="location.id">
                                            <td class="" >
                                               {{ location.description }}
                                            </td>
                                            <td class="">
                                               <span v-if="location.running"  :class="['badge bg-blue text-uppercase']"  v-text="location.en_cours"> </span> 
                                               <span v-else-if="location.waiting"  :class="['badge badge-warning text-uppercase']"  v-text="location.en_cours"> </span> 
                                               <span v-else :class="['badge badge-danger text-uppercase']"  v-text="location.en_cours"> </span> 

                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div v-else>
                                    <div class="d-flex flex-column justify-content-center no-variations-chart text-center" style="">
                                          <p class="mb-0"><span class="icon-image" ><i class="las la-book mr-1"></i></span></p>
                                          <p class="text-center pb-0 mb-1" style="">
                                                <span>
                                                    Aucune <strong>location</strong> disponible pour le moment.
                                                </span>
                                          </p>
                                          <p v-if="authorize('can','ajoute-location')"   class="text-center mb-2" style=""><span>
                                                     <span > Vous pouvez en ajouter une nouvelle en cliquant sur  le bouton ci-dessous</span>
                                        </span>
                                          </p>
                                          <p v-if="authorize('can','ajoute-location')"   class="text-center mb-2">
                                             <router-link to="/locations/ajout" v-if="authorize('can','ajoute-location')"  class="btn btn-sm btn-primary "><i class="las la-plus mr-1"></i> Nouvelle location</router-link>
                                          </p>
                                      </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.card-body -->
                        <div v-if="entities.locations.length > 0" class="card-footer clearfix" style="display: block;">
                            <router-link to="/locations/ajout" v-if="authorize('can','ajoute-location')"  class="btn btn-sm btn-primary float-left">Nouvelle location</router-link>
                            <router-link to="/locations" class="btn btn-sm btn-secondary float-right">Voir toutes les locations</router-link>
                        </div>
                        <!-- /.card-footer -->
                    </div>
                  </div>
                  <div class="col-lg-12 col-md-12 col-sm-12">
                      <div class="card ">
                        <div class="card-header">
                            <h3 class="card-title d-flex align-items-center "><i style="font-size:30px" class="las la-wallet mr-1"></i><b>Derniers flux financiers</b></h3>

                            <div class="card-tools">
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display: block;">
                            <div class="table-responsive" v-if="entities.finances.length > 0">
                                <table class="table m-0">
                                    <thead>
                                        <tr>                                            
                                            <th class="align-" >Description</th>
                                            <th class="">Montant (En F cfa)</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="finance in entities.finances" :key="finance.id">
                                            <td class="" >
                                               {{ finance.flux }}
                                            </td>
                                            <td class="" >
                                               {{ finance.montant | monnaie }} <Small> </Small>
                                            </td>

                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div v-else>
                                    <div class="d-flex flex-column justify-content-center no-variations-chart text-center" style="">
                                          <p class="mb-0"><span class="icon-image" ><i class="las la-wallet"></i></span></p>
                                          <p class="text-center pb-0 mb-1" style="">
                                                <span>
                                                    Aucun <strong>flux financier</strong> disponible pour le moment.
                                                </span>
                                          </p>
                                      </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <div v-if="entities.finances.length > 0" class="card-footer clearfix" style="display: block;">
                          <router-link to="/flux-finances" class="btn btn-sm btn-secondary float-right">Voir toutes les flux</router-link>
                        </div>
                        <!-- /.card-footer -->
                    </div>
                  </div>
                 </div>
                 <div class="col-lg-3  col-md-12 col-sm-12">
                      <div class="row">
                  <div class="col-md-12">
                      <div class="card bloc-recent-history ">
                        <div class="card-header">
                            <h3 class="card-title d-flex align-items-center "><i style="font-size:30px" class="las la-history mr-1"></i><b>Historique récent</b></h3>

                            <div class="card-tools">
                            <router-link v-if="entities.historiques.length > 0" to="/historiques" class="btn btn-sm btn-secondary float-right">En voir plus</router-link>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body p-0" style="display: block;">
                            <div class="table-responsive" v-if="entities.historiques.length > 0">
                                <table class="table m-0">
                                    <thead v-show="false">
                                        <tr>
                                            <th class="" >Description</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="h in entities.historiques" :key="h.id">
                                            <td class="" >
                                                   <span v-html="h.as_someone_else"></span>
                                                   <br>
                                                   <span class="bloc-recent-history-date"> <i class="fa fa-clock mr-1"></i> <span class="bloc-recent-history-date-text" >{{ h.created_at | toDateTime }}</span>    </span>
                                                   
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                            <div v-else>
                                    <div class="d-flex flex-column justify-content-center no-variations-chart text-center" style="">
                                          <p class="mb-0"><span class="icon-image" ><i class="las la-history"></i></span></p>
                                          <p class="text-center pb-0 mb-1" style="">
                                                <span>
                                                    Aucun <strong>historique</strong> disponible pour le moment.
                                                </span>
                                          </p>
                                      </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.card-body -->
                        <!-- /.card-footer -->
                    </div>
                  </div>
                      </div>
                 </div>
            </div>
        </div><!-- /.container-fluid -->
        </section>
        <!-- /.content -->
    </div>
</template>

<script>

   import Master from "./Master.vue";
   import ChiffreAffaireGraph from './../components/ChiffreAffaireGraph.vue'

    export default {
            components: {
      ChiffreAffaireGraph
    },
        mixins: [Master],

        data()
          {
            return{ 
                entities:{
                    ca: "",
                    clients_count: "",
                    finances:[],
                    historiques:[],
                    locations:[],
                    locations_annulees_count: "",
                    locations_count: "",
                    locations_en_cours_count: "",
                    users_count: "",
                    vehicules_count: "",
                    vpp: "",
                    vmp: "",
                    cpp:""
                },
                anneEnCours:moment().year(),
                dataLoaded:false,
                waiting:
        {
            graph:false,
            entities:false,
        },
         }
        },
        computed:
        {
           init()
           {
               var objectKeys = Object.keys(this.waiting);
               objectKeys.forEach((key) => {
                  if(key==false)
                  return false
               })

            
            return true
           },
           hasBestCar()
           {
               return isDefined(this.entities.vpp) ? true : false
           },
            hasWorstCar()
           {
               return isDefined(this.entities.vmp) ? true : false
           },
            hasBestClient()
           {
               return isDefined(this.entities.cpp) ? true : false
           }
        },
        created()
         {
            this.pageInit = false
            this.fetch()
        },
        mounted()
        {
            window.event.$on('ca-graph-loaded',e => {
                this.waiting.graph = true
                this.pageInit = true
            })

        },
        methods:
        {

             fetch()
             {
                var url = "api/dashboard"
                axios.get(url,{ params : this.params }).then((response) => 
                { 

                       this.entities = response.data
                       this.waiting.entities = true
                       this.dataLoaded = true
                       
                               
                },
                (error) => {
                         console.log("Promise Rejected:")

                });
             },
                   fillData () {
        this.datacollection = {
          labels: [this.getRandomInt(), this.getRandomInt()],
          datasets: [
            {
              label: 'Data One',
              backgroundColor: '#f87979',
              data: [this.getRandomInt(), this.getRandomInt()]
            }, {
              label: 'Data One',
              backgroundColor: '#f87979',
              data: [this.getRandomInt(), this.getRandomInt()]
            }
          ]
        }
      },
      getRandomInt () {
        return Math.floor(Math.random() * (50 - 5 + 1)) + 5
      }
        },
           
    }
</script>
<style scoped>
   .small-box{
       min-height: 111px;
   }
     .small {
    max-width: 100%;
  }
  .widget-user-header
  {
      color:black;
  }
  .widget-user-image .icon
  {
    float: left;
    height: auto;
    font-size: 80px;
  }
    .widget-user-2 .widget-user-header
  {
     color :black !important;
  }
    .widget-user-2 li.nav-item  a
  {
     cursor:default !important;
     color :black;
  }
      .widget-user-2 li.nav-item:last-child  a
  {
     cursor: pointer !important;
  }
  .widget-user-2 li.nav-item  span.float-right
  {
      color :black;
  }

  .bloc-recent-history-date-text
  {
    color: #6c757d;
    font-size: 0.8rem;
  }
</style>